diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/AcceptedTaxonBridge.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/AcceptedTaxonBridge.java
index 80d4aff962..a5b46ab71b 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/AcceptedTaxonBridge.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/AcceptedTaxonBridge.java
@@ -12,60 +12,92 @@ import java.util.Set;
 
 import org.apache.lucene.document.Document;
 import org.apache.lucene.document.Field;
+import org.apache.lucene.document.Field.Index;
 import org.hibernate.search.bridge.FieldBridge;
 import org.hibernate.search.bridge.LuceneOptions;
 
-import eu.etaxonomy.cdm.model.name.NomenclaturalCode;
 import eu.etaxonomy.cdm.model.taxon.Synonym;
 import eu.etaxonomy.cdm.model.taxon.SynonymRelationship;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
+import eu.etaxonomy.cdm.model.taxon.TaxonBase;
 
 /**
- * Lucene index class bridge which sets the uuids of the accepted taxon for the 
+ * Lucene index class bridge which sets the uuids of the accepted taxon for the
  * TaxonBase object into the index.
+ * <p>
+ * Adds multivalued id fields with the uuid and id of the accepted taxa of the
+ * current {@link TaxonBase} entity. Id fields should not be analyzed, therefore
+ * this FieldBridge ignores the settings {@link org.hibernate.annotations.Index}
+ * annotation and always sets this to <code>NOT_ANALYZED</code>.
+ *
  *
  * @author c.mathew
+ * @author a.kohlbecker
  * @version 1.0
  * @created 26 Jul 2013
  */
-public class AcceptedTaxonBridge implements FieldBridge {
+public class AcceptedTaxonBridge implements FieldBridge { // TODO inherit from AbstractClassBridge since this base class provides presets for id fields?
+
+    public final static String ACCEPTED_TAXON_UUID_LIST_SEP = ",";
+    private final static String DOC_KEY_UUID_SUFFIX = ".uuids"; // TODO do not use the plural for the field name
+    private static final String DOC_KEY_ID_SUFFIX = ".id";
+
+    @Override
+    public void set(String name, Object value, Document document,
+            LuceneOptions luceneOptions) {
+        String accTaxonUuids = "";
 
-	public final static String ACCEPTED_TAXON_UUID_LIST_SEP = ",";
-	private final static String DOC_KEY_SUFFIX = ".uuids";
-	
-	@Override
-	public void set(String name, Object value, Document document,
-			LuceneOptions luceneOptions) {
-		String accTaxonUuids = "";
-		
-		// in the case of taxon this is just the uuid
-		if(value instanceof Taxon) {
-			accTaxonUuids = ((Taxon)value).getUuid().toString();
-		}				
-		// in the case of synonym this is the accepted taxon in the synonym
-		// relationships
+        // in the case of taxon this is just the uuid
+        if(value instanceof Taxon) {
+            accTaxonUuids = ((Taxon)value).getUuid().toString();
+            Field canonicalNameIdField = new Field(name + DOC_KEY_ID_SUFFIX,
+                    Integer.toString(((Taxon)value).getId()),
+                    luceneOptions.getStore(),
+                    Index.NOT_ANALYZED,
+                    Field.TermVector.NO
+                    );
+            document.add(canonicalNameIdField);
+        }
+        // in the case of synonym this is the accepted taxon in the synonym
+        // relationships
         if (value instanceof Synonym) {
-        	StringBuilder sb = new StringBuilder(); 
+            StringBuilder sb = new StringBuilder();
             Synonym synonym = (Synonym) value;
             Set<SynonymRelationship> synRelationships = synonym.getSynonymRelations();
             for (SynonymRelationship sr : synRelationships) {
-            	Taxon accTaxon = sr.getAcceptedTaxon();
-            	sb.append(accTaxon.getUuid().toString());
-            	sb.append(ACCEPTED_TAXON_UUID_LIST_SEP);
+                Taxon accTaxon = sr.getAcceptedTaxon();
+                sb.append(accTaxon.getUuid().toString());
+                sb.append(ACCEPTED_TAXON_UUID_LIST_SEP);
+
+                // adding the accTaxon id as multivalue field:
+                Field canonicalNameIdField = new Field(name + DOC_KEY_ID_SUFFIX,
+                        Integer.toString(accTaxon.getId()),
+                        luceneOptions.getStore(),
+                        Index.NOT_ANALYZED,
+                        Field.TermVector.NO
+                        );
+                document.add(canonicalNameIdField);
             }
             accTaxonUuids = sb.toString();
             if(accTaxonUuids.length() > 0) {
-            	accTaxonUuids = accTaxonUuids.substring(0, accTaxonUuids.length()-1);
+                accTaxonUuids = accTaxonUuids.substring(0, accTaxonUuids.length()-1);
             }
         }
 
-        Field canonicalNameField = new Field(name + DOC_KEY_SUFFIX,
-        		accTaxonUuids,
-        		luceneOptions.getStore(),
-        		luceneOptions.getIndex(),
-        		luceneOptions.getTermVector());
-        canonicalNameField.setBoost(luceneOptions.getBoost());
-        document.add(canonicalNameField);
+        // TODO can't we also add the uuid as multivalue field?
+
+        // the id field is shorter and should be sufficient
+        Field canonicalNameUuidField = new Field(name + DOC_KEY_UUID_SUFFIX,
+                accTaxonUuids,
+                luceneOptions.getStore(),
+                Index.NOT_ANALYZED,
+                Field.TermVector.NO);
+        //TODO  do we really need to set the boost for an id field?
+        canonicalNameUuidField.setBoost(luceneOptions.getBoost());
+        document.add(canonicalNameUuidField);
+
+
+
 
-	}
+    }
 }
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/ClassInfoBridge.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/ClassInfoBridge.java
index 07ec24b9d4..42c8bcea4b 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/ClassInfoBridge.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/ClassInfoBridge.java
@@ -13,7 +13,11 @@ import org.apache.lucene.document.Field;
 import org.hibernate.search.bridge.FieldBridge;
 import org.hibernate.search.bridge.LuceneOptions;
 /**
- * Lucene index class bridge which sets class information for the objects into the index
+ * Lucene index class bridge which sets class information for the objects into the index.
+ *
+ * TODO: is this class really needed?
+ *  1. the canonical name should for all cdm types be he same as the name
+ *  2. the class name is already stored in the document as _hibernate_class
  *
  * @author c.mathew
  * @version 1.0
@@ -21,24 +25,24 @@ import org.hibernate.search.bridge.LuceneOptions;
  */
 public class ClassInfoBridge implements FieldBridge {
 
-	@Override
-	public void set(String name, Object value, Document document,
-			LuceneOptions luceneOptions) {
-		Field nameField = new Field(name + ".name",
-				value.getClass().getName(),
-				luceneOptions.getStore(),
-				luceneOptions.getIndex(),
-				luceneOptions.getTermVector());
-		nameField.setBoost(luceneOptions.getBoost());
-		document.add(nameField);
-		
-		Field canonicalNameField = new Field(name + ".canonicalName",
-				value.getClass().getCanonicalName(),
-				luceneOptions.getStore(),
-				luceneOptions.getIndex(),
-				luceneOptions.getTermVector());
-		canonicalNameField.setBoost(luceneOptions.getBoost());
-		document.add(canonicalNameField);
+    @Override
+    public void set(String name, Object value, Document document,
+            LuceneOptions luceneOptions) {
+        Field nameField = new Field(name + ".name",
+                value.getClass().getName(),
+                luceneOptions.getStore(),
+                luceneOptions.getIndex(),
+                luceneOptions.getTermVector());
+        nameField.setBoost(luceneOptions.getBoost());
+        document.add(nameField);
+
+        Field canonicalNameField = new Field(name + ".canonicalName",
+                value.getClass().getCanonicalName(),
+                luceneOptions.getStore(),
+                luceneOptions.getIndex(),
+                luceneOptions.getTermVector());
+        canonicalNameField.setBoost(luceneOptions.getBoost());
+        document.add(canonicalNameField);
 
-	}
+    }
 }
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/DoiBridge.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/DoiBridge.java
new file mode 100644
index 0000000000..20f43decc9
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/DoiBridge.java
@@ -0,0 +1,30 @@
+/**
+* Copyright (C) 2012 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+
+package eu.etaxonomy.cdm.hibernate.search;
+
+import org.hibernate.search.bridge.StringBridge;
+
+import eu.etaxonomy.cdm.common.DOI;
+
+/**
+ * @author a.mueller
+ * @date Sep 05, 2013
+ *
+ */
+public class DoiBridge implements StringBridge {
+
+    public String objectToString(Object object) {
+        if(object != null) {
+            return ((DOI)object).toString();
+        }
+        return null;
+    }
+
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/TaxonRelationshipClassBridge.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/TaxonRelationshipClassBridge.java
new file mode 100644
index 0000000000..9ecd47ee7a
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/hibernate/search/TaxonRelationshipClassBridge.java
@@ -0,0 +1,93 @@
+// $Id$
+/**
+* Copyright (C) 2013 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.hibernate.search;
+
+import java.util.Set;
+
+import org.apache.log4j.Logger;
+import org.apache.lucene.document.Document;
+import org.apache.lucene.document.Field;
+import org.hibernate.search.bridge.LuceneOptions;
+
+import eu.etaxonomy.cdm.model.taxon.Taxon;
+import eu.etaxonomy.cdm.model.taxon.TaxonRelationship;
+
+/**
+ * Adds fields for related to and related from taxon relations.
+ *
+ *
+ * @author a.kohlbecker
+ * @date Sep 24, 2013
+ *
+ */
+public class TaxonRelationshipClassBridge extends AbstractClassBridge {
+
+    public static final Logger logger = Logger.getLogger(TaxonRelationshipClassBridge.class);
+
+    private static final String FROM = ".from.";
+    private static final String TO = ".to.";
+
+    /* (non-Javadoc)
+     * @see eu.etaxonomy.cdm.hibernate.search.AbstractClassBridge#set(java.lang.String, java.lang.Object, org.apache.lucene.document.Document, org.hibernate.search.bridge.LuceneOptions)
+     */
+    @Override
+    public void set(String name, Object value, Document document, LuceneOptions luceneOptions) {
+        if(value instanceof Taxon){
+
+            String fieldName = name;
+            if(!fieldName.isEmpty()){
+                fieldName += ".";
+            }
+
+            Taxon taxon = (Taxon)value;
+
+            String directionName = FROM;
+            addRelationsFields(fieldName, document, directionName, taxon.getRelationsToThisTaxon());
+
+            directionName = TO;
+            addRelationsFields(fieldName, document, directionName, taxon.getRelationsFromThisTaxon());
+
+        } else {
+            logger.error("Unsupported type " + value.getClass());
+        }
+
+    }
+
+    /**
+     * @param name
+     * @param document
+     * @param directionName
+     * @param relations
+     */
+    private void addRelationsFields(String name, Document document, String directionName,
+            Set<TaxonRelationship> relations) {
+        Taxon relTaxon;
+
+        for(TaxonRelationship rel : relations){
+
+            if(directionName.equals(FROM)){
+                relTaxon = rel.getFromTaxon();
+            } else {
+                relTaxon = rel.getToTaxon();
+            }
+
+            Field relfield = new Field(
+                    name + "relation." + rel.getType().getUuid().toString() + directionName + "id",
+                    Integer.toString(relTaxon.getId()),
+                    idFieldOptions.getStore(),
+                    idFieldOptions.getIndex(),
+                    idFieldOptions.getTermVector()
+                    );
+            relfield.setBoost(idFieldOptions.getBoost());
+            document.add(relfield);
+        }
+    }
+
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/CdmBaseType.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/CdmBaseType.java
index 7fcef2219f..7dd5f301de 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/CdmBaseType.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/CdmBaseType.java
@@ -33,6 +33,9 @@ import eu.etaxonomy.cdm.model.taxon.TaxonBase;
  */
 public enum CdmBaseType {
 
+    /**
+     * refers to the baseClass {@link TaxonBase}
+     */
     TAXON(TaxonBase.class),
     NONVIRALNAME(TaxonNameBase.class),
     DESCRIPTION_ELEMENT(DescriptionElementBase.class),
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/Address.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/Address.java
index 3ec793ebe1..d2646a67d2 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/Address.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/Address.java
@@ -26,7 +26,7 @@ import org.hibernate.envers.Audited;
 
 import eu.etaxonomy.cdm.model.common.VersionableEntity;
 import eu.etaxonomy.cdm.model.location.Point;
-import eu.etaxonomy.cdm.model.location.WaterbodyOrCountry;
+import eu.etaxonomy.cdm.model.location.Country;
 
 /**
  * This class represents atomized postal addresses.
@@ -63,7 +63,7 @@ public class Address extends VersionableEntity implements Cloneable{
 		return new Address();
 	}
 	
-    public static Address NewInstance(WaterbodyOrCountry country,
+    public static Address NewInstance(Country country,
 			String locality, String pobox, String postcode,
 			String region, String street, Point location) {
 		return new Address(country, locality, location, pobox, postcode,
@@ -74,7 +74,7 @@ public class Address extends VersionableEntity implements Cloneable{
     	
     }
     
-	private Address(WaterbodyOrCountry country, String locality, Point location,
+	private Address(Country country, String locality, Point location,
 			String pobox, String postcode, String region, String street) {
 		super();
 		this.country = country;
@@ -105,24 +105,24 @@ public class Address extends VersionableEntity implements Cloneable{
     @XmlIDREF
     @XmlSchemaType(name = "IDREF")
     @ManyToOne(fetch = FetchType.LAZY)
-	private WaterbodyOrCountry country;
+	private Country country;
     
     @XmlElement(name = "Location")
 	private Point location;
 	
 	/**
-	 * Returns the {@link WaterbodyOrCountry country} involved in <i>this</i> postal address.
+	 * Returns the {@link Country country} involved in <i>this</i> postal address.
 	 * 
 	 * @return	the country 
 	 */
-	public WaterbodyOrCountry getCountry(){
+	public Country getCountry(){
 		return this.country;
 	}
 
 	/**
 	 * @see			   #getCountry()
 	 */
-	public void setCountry(WaterbodyOrCountry country){
+	public void setCountry(Country country){
 		this.country = country;
 	}
 
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/AgentBase.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/AgentBase.java
index f59faedc52..390fe5e23e 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/AgentBase.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/AgentBase.java
@@ -26,7 +26,7 @@ import org.hibernate.annotations.Table;
 import org.hibernate.envers.Audited;
 
 import eu.etaxonomy.cdm.model.location.Point;
-import eu.etaxonomy.cdm.model.location.WaterbodyOrCountry;
+import eu.etaxonomy.cdm.model.location.Country;
 import eu.etaxonomy.cdm.model.media.IdentifiableMediaEntity;
 import eu.etaxonomy.cdm.strategy.cache.common.IIdentifiableEntityCacheStrategy;
 import eu.etaxonomy.cdm.strategy.match.IMatchable;
@@ -115,10 +115,10 @@ public abstract class AgentBase<S extends IIdentifiableEntityCacheStrategy> exte
 	 * @param pobox
 	 * @param region
 	 * @param location
-	 * @see eu.etaxonomy.cdm.model.agent.Contact#addAddress(java.lang.String, java.lang.String, java.lang.String, eu.etaxonomy.cdm.model.location.WaterbodyOrCountry, java.lang.String, java.lang.String, eu.etaxonomy.cdm.model.location.Point)
+	 * @see eu.etaxonomy.cdm.model.agent.Contact#addAddress(java.lang.String, java.lang.String, java.lang.String, eu.etaxonomy.cdm.model.location.Country, java.lang.String, java.lang.String, eu.etaxonomy.cdm.model.location.Point)
 	 */
 	public void addAddress(String street, String postcode, String locality,
-			WaterbodyOrCountry country, String pobox, String region,
+			Country country, String pobox, String region,
 			Point location) {
 		getNewOrExistingContact(true).addAddress(street, postcode, locality, country, pobox, region,
 				location);
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/Contact.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/Contact.java
index f38e2d76a0..7e521a53c7 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/Contact.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/Contact.java
@@ -35,7 +35,7 @@ import org.hibernate.annotations.CascadeType;
 import org.hibernate.envers.Audited;
 
 import eu.etaxonomy.cdm.model.location.Point;
-import eu.etaxonomy.cdm.model.location.WaterbodyOrCountry;
+import eu.etaxonomy.cdm.model.location.Country;
 import eu.etaxonomy.cdm.strategy.merge.MergeException;
 
 /**
@@ -88,7 +88,7 @@ public class Contact implements Serializable, Cloneable {
 	 * @return
 	 */
 	public static Contact NewInstance(String street, String postcode, String locality,
-			WaterbodyOrCountry country, String pobox, String region,
+			Country country, String pobox, String region,
 			String email, String faxNumber, String phoneNumber, String url, Point location) {
 		Contact result = new Contact();
 		if (country != null || StringUtils.isNotBlank(locality) || StringUtils.isNotBlank(pobox) || StringUtils.isNotBlank(postcode) ||
@@ -226,7 +226,7 @@ public class Contact implements Serializable, Cloneable {
 	}
 
 	public void addAddress(String street, String postcode, String locality,
-			WaterbodyOrCountry country, String pobox, String region, Point location){
+			Country country, String pobox, String region, Point location){
 		Address newAddress = Address.NewInstance(country, locality, pobox, postcode, region, street, location);
 		getAddresses().add(newAddress);
 	}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/Institution.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/Institution.java
index 6e7f0c00f7..3d72ac602f 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/Institution.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/agent/Institution.java
@@ -35,9 +35,9 @@ import org.hibernate.search.annotations.Field;
 import org.hibernate.search.annotations.Indexed;
 import org.springframework.beans.factory.annotation.Configurable;
 
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.strategy.cache.agent.InstitutionDefaultCacheStrategy;
 import eu.etaxonomy.cdm.strategy.cache.common.IIdentifiableEntityCacheStrategy;
-import eu.etaxonomy.cdm.validation.annotation.NullOrNotEmpty;
 
 /**
  * This class represents public or private institutions.
@@ -88,7 +88,7 @@ public class Institution extends AgentBase<IIdentifiableEntityCacheStrategy<Inst
     @XmlIDREF
     @XmlSchemaType(name = "IDREF")
     @ManyToMany(fetch = FetchType.LAZY)
-	private Set<InstitutionType> types;
+	private Set<DefinedTerm> types;  //InstitutionTypes
 
     @XmlElement(name = "IsPartOf")
     @XmlIDREF
@@ -114,16 +114,15 @@ public class Institution extends AgentBase<IIdentifiableEntityCacheStrategy<Inst
 	}
 
 	/**
-	 * Returns the set of institution {@link InstitutionType types} (categories)
+	 * Returns the set of institution types (categories)
 	 * used to describe or circumscribe <i>this</i> institution's activities.
 	 * Institution types are items of a controlled {@link eu.etaxonomy.cdm.model.common.TermVocabulary vocabulary}.
 	 *
 	 * @return	the set of institution types
-	 * @see     InstitutionType
 	 */
-	public Set<InstitutionType> getTypes(){
+	public Set<DefinedTerm> getTypes(){
 		if(types == null) {
-			this.types = new HashSet<InstitutionType>();
+			this.types = new HashSet<DefinedTerm>();
 		}
 		return this.types;
 	}
@@ -134,10 +133,9 @@ public class Institution extends AgentBase<IIdentifiableEntityCacheStrategy<Inst
 	 *
 	 * @param  t  any type of institution
 	 * @see 	  #getTypes()
-	 * @see 	  InstitutionType
 	 */
-	public void addType(InstitutionType t){
-		getTypes().add(t);
+	public void addType(DefinedTerm type){
+		getTypes().add(type);
 	}
 
 	/**
@@ -146,8 +144,8 @@ public class Institution extends AgentBase<IIdentifiableEntityCacheStrategy<Inst
 	 * @param  t  the institution type which should be deleted
 	 * @see       #getTypes()
 	 */
-	public void removeType(InstitutionType t){
-		getTypes().remove(t);
+	public void removeType(DefinedTerm type){
+		getTypes().remove(type);
 	}
 
 	/**
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/AnnotatableEntity.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/AnnotatableEntity.java
index c5a92b6f0d..6f9c9b84c7 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/AnnotatableEntity.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/AnnotatableEntity.java
@@ -60,7 +60,7 @@ public abstract class AnnotatableEntity extends VersionableEntity implements IAn
 	@OneToMany(fetch=FetchType.LAZY, orphanRemoval=true)
 	@Cascade({CascadeType.SAVE_UPDATE, CascadeType.MERGE, CascadeType.DELETE})
 	@Merge(MergeMode.ADD_CLONE)
-	protected Set<Annotation> annotations;
+	protected Set<Annotation> annotations = new HashSet<Annotation>();;
 	
 	protected AnnotatableEntity() {
 		super();
@@ -105,10 +105,7 @@ public abstract class AnnotatableEntity extends VersionableEntity implements IAn
 
 //*************** ANNOTATIONS **********************************************
 	
-	public Set<Annotation> getAnnotations(){
-		if(annotations == null) {
-			this.annotations = new HashSet<Annotation>();
-		}
+	public Set<Annotation> getAnnotations(){		
 		return this.annotations;
 	}
 	public void addAnnotation(Annotation annotation){
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/Annotation.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/Annotation.java
index f5cd3519e7..316e24b3e4 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/Annotation.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/Annotation.java
@@ -29,6 +29,7 @@ import org.apache.log4j.Logger;
 import org.hibernate.annotations.Any;
 import org.hibernate.annotations.Cascade;
 import org.hibernate.annotations.CascadeType;
+import org.hibernate.annotations.Type;
 import org.hibernate.envers.Audited;
 import org.hibernate.envers.NotAudited;
 
@@ -79,19 +80,6 @@ public class Annotation extends LanguageStringBase implements Cloneable {
 		return new Annotation(text, Language.DEFAULT());
 	}
 
-	protected Annotation(){
-		super();
-	}
-
-	/**
-	 * Constructor
-	 * @param text
-	 * @param lang
-	 */
-	protected Annotation(String text, Language language) {
-		super(text, language);
-	}
-
 
 	//Human annotation
 	@XmlElement(name = "Commentator")
@@ -118,13 +106,32 @@ public class Annotation extends LanguageStringBase implements Cloneable {
     @ManyToOne(fetch = FetchType.LAZY)
 	private AnnotationType annotationType;
 
-	// for external annotations/comments the URL of these can be set.
+	// for external annotations/comments the URI of these can be set.
 	// should be useful to implement trackback, pingback or linkback:
 	// http://en.wikipedia.org/wiki/Linkback
-	@XmlElement(name = "LinkbackURL") // TODO tell JAXB to use the new field name: linkbackUri
-	@Column(name="linkbackUrl") // TODO upgrade databases to new field name linkbackUri
+	@XmlElement(name = "LinkbackUri")
+	@Type(type="uriUserType")
 	private URI linkbackUri;
 
+	
+// *********** CONSTRUCTOR **************************************/
+	
+	protected Annotation(){
+		super();
+	}
+
+	/**
+	 * Constructor
+	 * @param text
+	 * @param lang
+	 */
+	protected Annotation(String text, Language language) {
+		super(text, language);
+	}
+
+//******************** GETTER /SETTER *************************/	
+	
+
 	/**
 	 * Currently envers does not support @Any
 	 * @return
@@ -132,7 +139,7 @@ public class Annotation extends LanguageStringBase implements Cloneable {
 	public AnnotatableEntity getAnnotatedObj() {
 		return annotatedObj;
 	}
-
+	
 	//TODO make not public, but TaxonTaoHibernateImpl.delete has to be changed then
 	/**
 	 *
@@ -167,28 +174,6 @@ public class Annotation extends LanguageStringBase implements Cloneable {
 		this.linkbackUri = linkbackUri;
 	}
 
-	/**
-	 * private get/set methods for Hibernate that allows us to save the URL as strings
-	 * @return
-	 */
-	private String getLinkbackUriStr() {
-		if (linkbackUri == null){
-			return null;
-		}
-		return linkbackUri.toString();
-	}
-	private void setLinkbackUriStr(String linkbackUriString) {
-		if (linkbackUriString == null){
-			this.linkbackUri = null;
-		}else{
-			try {
-				this.linkbackUri = new URI(linkbackUriString);
-			} catch (URISyntaxException e) {
-                // TODO Auto-generated catch block
-                e.printStackTrace();
-            }
-		}
-	}
 
 // ***************************** TO STRING ***********************************
 
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/AnnotationType.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/AnnotationType.java
index ddecbdb71b..a68c732ad9 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/AnnotationType.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/AnnotationType.java
@@ -23,12 +23,10 @@ import javax.xml.bind.annotation.XmlType;
 import org.apache.log4j.Logger;
 import org.hibernate.envers.Audited;
 import org.hibernate.search.annotations.Indexed;
-import org.springframework.util.Assert;
 
 /**
  * Annotation types ...
  * @author a.mueller
- * @version 1.0
  * @created 12-Nov-2008 15:37:33
  */
 @XmlAccessorType(XmlAccessType.FIELD)
@@ -51,12 +49,12 @@ public class AnnotationType extends DefinedTermBase<AnnotationType> {
 		return new AnnotationType(term, label, labelAbbrev);
 	}
 	
-	/**
-	 * Constructor
-	 * @param term
-	 * @param label
-	 */
-	public AnnotationType() {
+//********************************** Constructor *******************************************************************/	
+
+	//for hibernate use only
+	@Deprecated
+	protected AnnotationType() {
+		super(TermType.AnnotationType);
 	}
 	
 	/**
@@ -65,7 +63,7 @@ public class AnnotationType extends DefinedTermBase<AnnotationType> {
 	 * @param label
 	 */
 	protected AnnotationType(String term, String label, String labelAbbrev) {
-		super(term, label, labelAbbrev);
+		super(TermType.AnnotationType , term, label, labelAbbrev);
 	}
 
 	
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/DefaultTermInitializer.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/DefaultTermInitializer.java
index 48ee0b3fe8..3bf3463538 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/DefaultTermInitializer.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/DefaultTermInitializer.java
@@ -8,6 +8,7 @@
 */
 package eu.etaxonomy.cdm.model.common;
 
+import java.lang.reflect.Constructor;
 import java.util.HashMap;
 import java.util.Map;
 import java.util.UUID;
@@ -45,17 +46,19 @@ public class DefaultTermInitializer implements ITermInitializer {
 	
 	protected void setDefinedTerms(Class<? extends DefinedTermBase<?>> clazz, TermVocabulary<?> vocabulary) {
 		DefinedTermBase newInstance;
+		newInstance = getInstance(clazz);
+		newInstance.setDefaultTerms(vocabulary);
+	}
+	
+	private  <T extends DefinedTermBase> T getInstance(Class<? extends DefinedTermBase> termClass) {
 		try {
-			newInstance = clazz.newInstance();
-			newInstance.setDefaultTerms(vocabulary);
-		} catch (InstantiationException e) {
-			// TODO Exception type
-			throw new RuntimeException("NewInstance could not be initialized in term initializer", e);
-		} catch (IllegalAccessException e) {
-			// TODO Exception type
-			throw new RuntimeException("NewInstance could not be accessed in term initializer", e);
+			Constructor<T> c = ((Class<T>)termClass).getDeclaredConstructor();
+			c.setAccessible(true);
+			T termInstance = c.newInstance();
+			return termInstance;
+		} catch (Exception e) {
+			throw new RuntimeException(e);
 		}
-		
 	}
 
 
